#ifndef _KINGHT_HEAD_H
#define _KNIGHT_HEAD_H


#include <stdio.h>
#include <math.h>

#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>

#include <Inventor/nodes/SoGroup.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoFaceSet.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/SbLinear.h>


class knight_head 
{
  float HEIGHT;
  float WIDTH;
  float DEPTH;

  SoGroup *knight_head_root;

public:

  knight_head(float height, float width, float depth);
  SoGroup *getGeometry();
};



knight_head::knight_head(float height = 10.0, float width = 6.0, float depth = 2.0)
{

// Default is arbitrary knight head

  HEIGHT = height;
  WIDTH = width;
  DEPTH = depth;


// The knight head will start drawing itself at the FRONT BOTTOM LEFT
// corner. It will consist of a FaceSet node to specify the vertices.


  SbVec3f coords3d[52];

  coords3d[0] = SbVec3f(0, 0, 0);
  coords3d[1] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , 0);
  coords3d[2] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, 0);
  coords3d[3] = SbVec3f(WIDTH, 0, 0);

  coords3d[4] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , 0);
  coords3d[5] = SbVec3f(0, HEIGHT , 0);
  coords3d[6] = SbVec3f(WIDTH , HEIGHT , 0);
  coords3d[7] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, 0);

  coords3d[8] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, 0);
  coords3d[9] = SbVec3f(WIDTH , HEIGHT , 0);
  coords3d[10] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, 0);
  coords3d[11] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, 0);

  coords3d[12] = SbVec3f(0, 0, DEPTH);
  coords3d[13] = SbVec3f(WIDTH, 0, DEPTH);
  coords3d[14] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, DEPTH);
  coords3d[15] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , DEPTH);

  coords3d[16] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , DEPTH);
  coords3d[17] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, DEPTH);
  coords3d[18] = SbVec3f(WIDTH , HEIGHT , DEPTH);
  coords3d[19] = SbVec3f(0, HEIGHT , DEPTH);

  coords3d[20] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, DEPTH);
  coords3d[21] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, DEPTH);
  coords3d[22] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, DEPTH);
  coords3d[23] = SbVec3f(WIDTH , HEIGHT , DEPTH);

  coords3d[24] = SbVec3f(WIDTH, 0, 0);
  coords3d[25] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, 0);
  coords3d[26] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, DEPTH);
  coords3d[27] = SbVec3f(WIDTH, 0, DEPTH);

  coords3d[28] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, 0);
  coords3d[29] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, 0);
  coords3d[30] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, DEPTH);
  coords3d[31] = SbVec3f(WIDTH/2, (3.0/5.0)*HEIGHT, DEPTH);

  coords3d[32] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, 0);
  coords3d[33] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, 0);
  coords3d[34] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, DEPTH);
  coords3d[35] = SbVec3f((5.0/4.0)*WIDTH, (2.5/5.0)*HEIGHT, DEPTH);

  coords3d[36] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, 0);
  coords3d[37] = SbVec3f(WIDTH , HEIGHT , 0);
  coords3d[38] = SbVec3f(WIDTH , HEIGHT , DEPTH);
  coords3d[39] = SbVec3f((3.0/2.0)*WIDTH, (3.5/5.0)*HEIGHT, DEPTH);

  coords3d[40] = SbVec3f(WIDTH , HEIGHT , 0);
  coords3d[41] = SbVec3f(0, HEIGHT , 0);
  coords3d[42] = SbVec3f(0, HEIGHT , DEPTH);
  coords3d[43] = SbVec3f(WIDTH , HEIGHT , DEPTH);

  coords3d[44] = SbVec3f(0, HEIGHT , 0);
  coords3d[45] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , 0);
  coords3d[46] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , DEPTH);
  coords3d[47] = SbVec3f(0, HEIGHT , DEPTH);

  coords3d[48] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , 0);
  coords3d[49] = SbVec3f(0, 0, 0);
  coords3d[50] = SbVec3f(0, 0, DEPTH);
  coords3d[51] = SbVec3f( -1*WIDTH/2 , (3.0/5.0)*HEIGHT , DEPTH);


  SoCoordinate3 *coord = new SoCoordinate3;
  coord->point.setValues(0, 52, coords3d);

  int vert_arr[13];
  for (int i=0; i<13; i++)
    vert_arr[i] = 4;

  SoFaceSet *head_fs = new SoFaceSet;
  head_fs->numVertices.setValues(0, 13, vert_arr);

  SoShapeHints *hints = new SoShapeHints;
  hints->vertexOrdering.setValue(SoShapeHints::CLOCKWISE);

  knight_head_root = new SoGroup;
  knight_head_root->ref();

  knight_head_root->addChild(hints);
  knight_head_root->addChild(coord);
  knight_head_root->addChild(head_fs);
}


SoGroup *knight_head::getGeometry()
{
  return knight_head_root;
}


/*********************************************************/
/*   COMMENTED OUT AFTER THIS... END OF CODE :)  ....   **/         
/*********************************************************/

/*************************************
 * TEST main() for knight_head class *
 *************************************/

/*
int main(int, char **argv)	{

// Initialize Inventor

  Widget myWindow = SoXt::init(argv[0]);
  if (myWindow == NULL) exit(1);

  knight_head a(10.0,6.0,2.0);

// Set up viewer / Render area to see the scene graph

  SoXtExaminerViewer *viewer = new SoXtExaminerViewer(myWindow);
  viewer->setSceneGraph(a.getGeometry());
  viewer->setTitle("Madhulika");
  viewer->show();


  SoXt::show(myWindow);
  SoXt::mainLoop();
}

*/

#endif








